
function GdcaPKIService() {

 	var _webUtil = null;
	
	this.init = function(opt, onInited) {

        if(_webUtil == null){
    	    _webUtil = new WebUtility();

            _webUtil.setHttpTryPorts([55661]);
            _webUtil.setHttpsTryPorts([55662]);
            _webUtil.setWSTryPorts([55663, 55661]);
            _webUtil.setWSSTryPorts([55664, 55662]);

            _webUtil.init(opt, onInited);
        }

        return;
	};

	this.base64Encode = function(in_data) {
		return _webUtil.base64Encode(in_data);
    };
    
	this.base64Decode = function(in_data) {
		return _webUtil.base64Decode(in_data);
    };
    
	//1.获取接口版本号
    this.SOF_GetVersion = function(callback) {
	   var request = {
		   funcid:0
	   };

	   return _webUtil.Request(JSON.stringify(request), callback);
    };

	//2.获取产品版本号
	this.SOF_Ext_GetProductVersion = function(product_type, callback) {
        var request = {
			 funcid:49 ,
			 productType :product_type	
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//3.全局设置
	this.SOF_Config = function(setType, setVal, callback) {
        var request = {
			funcid:43,
			setType: setType,
			setVal: setVal
		};

		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//5.枚举设备
    this.SOF_Ext_EnumDevice = function(callback) {
		var request = {
			 funcid:37
		};
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//6.获取设备类型
	this.SOF_Ext_GetDeviceType = function(callback) {
		var request = {
			 funcid:42
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//7.枚举用户
    this.SOF_GetUserList = function(callback) {
	   var request = {
			 funcid:5,
			 ReturnMethod: 0
		};

		return _webUtil.Request(JSON.stringify(request), callback);
    };
	
	//8.获取设备信息
    this.SOF_GetDeviceInfo = function(container, DevInfoType, callback) {
		var request = {
			funcid:13,
			ContainerName: container,
			Type:DevInfoType
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//9.用户登录
    this.SOF_Login = function(container,PassWd, callback) {
		var request = {
			funcid:7,
			UserName: container,
			PassWd: _webUtil.base64Encode(PassWd)
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//10.判断是否登录
	this.SOF_Ext_isLogin = function(container,loginType, callback) {
		var request = {
			funcid:45,
			containerName: container,
			loginType: loginType
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//11.获取口令剩余次数
    this.SOF_GetPinRetryCount = function(container, callback) {
		var request = {
			funcid:8,
			ContainerName: container
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };
	
	//12.退出登录
    this.SOF_Ext_Logout = function(container,loginType, callback) {
		var request = {
			funcid:46,
			containerName: container,
			loginType: loginType
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//13.修改密码
    this.SOF_ChangePassWd = function(container, OldPassWd, NewPassWd, callback) {
        var request = {
			funcid:9,
			ContainerName: container,
			OldPassWd: _webUtil.base64Encode(OldPassWd),
			NewPassWd: _webUtil.base64Encode(NewPassWd)
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//14.读取证书
	this.SOF_ExportUserCert = function(container, callback) {
		var request = {
			funcid:6,
			ContainerName: container
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//14.读取加密证书
	this.SOF_ExportExChangeUserCert = function(container, callback) {
		var request = {
			funcid:10,
			ContainerName: container
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//15.解析证书信息
    this.SOF_GetCertInfo = function(Cert, Type, callback) {
        var request = {
			funcid:11,
			Cert: Cert,
			Type: Type
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//16.解析证书信息（OID）
    this.SOF_GetCertInfoByOid = function(Base64EncodeCert, OID, callback) {
         var request = {
			funcid:12,
			Cert: Base64EncodeCert,
			Oid: OID
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//17.证书验证
	 this.SOF_ValidateCert = function(Base64EncodeCert, callback) {
         var request = {
			funcid:14,
			Cert: Base64EncodeCert
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//18.P1签名
    this.SOF_SignData = function(container,InData, callback) {
		var request = {
			funcid:15,
			ContainerName: container,
			InData: InData
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//18.P1验签
    this.SOF_VerifySignedData = function(sign_cert, plain_data, signed_data, callback) {
		var request = {
			funcid:16,
			EncodeCert: sign_cert,
			InData: plain_data,
			SignValue: signed_data
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//20.P1文件签名
	this.SOF_SignFile = function(container, InFile, callback) {
		var request = {
			funcid:17,
			ContainerName: container,
			SInFilePath: InFile
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };
	
	//20.P1文件验签
	this.SOF_VerifySignedFile = function(Base64EncodeCert, InData,SignedValue, callback) {
		var request = {
			funcid:18,
			EncodeCert: Base64EncodeCert,
			InData: InData,
			SignValue: SignedValue
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//21.P7签名
    this.SOF_SignMessage = function(flag,container,InData, callback) {
		var request = {
			funcid:23,
			Flag: flag,
			ContainerName: container,
			InData: InData
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//21.P7验签
    this.SOF_VerifySignedMessage = function(SignedData, OriginalText, callback) {
		var request = {
			funcid:24,
			MessageData: SignedData,
			InData: OriginalText
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//21.P7解析签名
    this.SOF_GetInfoFromSignedMessage = function(MessageData, Type, callback) {
		var request = {
			funcid:25,
			MessageData: MessageData,
			Type: Type
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//23.P7文件签名
    this.SOF_Ext_PKCS7_SignFile = function(container, InFile, SignFileFlag, callback) {
		var request = {
			funcid:47,
			ContainerName: container,
			SInFilePath: InFile,
			SignFileFlag:SignFileFlag
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//23.P7文件验签
    this.SOF_Ext_PKCS7_VerifySignedFile = function(SignedData, InFilePath,SignFileFlag, callback) {
		var request = {
			funcid:48,
			MessageData: SignedData,
			SInFilePath: InFilePath,
			SignFileFlag:SignFileFlag
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

    //24.P7加解密设置格式
    this.SOF_Ext_SetEnvelopType = function(envType, callback) {
		var request = {
			funcid:39,
			envType: envType
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

    //24.p7加密
    this.SOF_EncryptData = function(Base64EncodeCert, InData, callback) {
		var request = {
			funcid:19,
			EncodeCert: Base64EncodeCert,
			InData: InData
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

    //24.P7解密
    this.SOF_DecryptData = function(container,InData, callback) {
		var request = {
			funcid:20,
			ContainerName: container,
			InData: InData
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

    //26 PKCS7文件加密
    this.SOF_EncryptFile = function(Cert, InFile, OutFile, callback) {
       	var request = {
			funcid: 21,
			EncodeCert: Cert,
			InFilePath: InFile,
			OutFilePath: OutFile
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

    //26 PKCS7文件解密
    this.SOF_DecryptFile = function(container, InFile, OutFile, callback) {
		var request = {
			funcid: 22,
			ContainerName: container,
			InFilePath: InFile,
			OutFilePath: OutFile
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

    //27.随机数
    this.SOF_GenRandom = function(length, callback) {
       var request = {
			funcid:26,
			Len: length
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

    //28.读标签
    this.SOF_Ext_ReadLabel = function(container, lableName, lableType, callback) {
       var request = {
			funcid:44,
			containerName: container,
			lableName: lableName,
			lableType: lableType
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//写读多用户数据
    this.SOF_Ext_WriteUsrDataFile = function(container,writePin,fileType,fileIndex,offSet,writeData, callback) {
       var request = {
			funcid:29,
			ContainerName: container,
			Pin: writePin,
			FileType: fileType,
			FileIndex: fileIndex,
			Offset: offSet,
			WriteData: writeData
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//读多用户数据
    this.SOF_Ext_ReadUsrDataFile = function(container,fileType,fileIndex,offset,readLen, callback) {
       var request = {
			funcid:28,
			ContainerName: container,
			FileType: fileType,
			FileIndex: fileIndex,
			Offset: offset,
			ReadLen: readLen
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//文件HASH
	this.SOF_Ext_HashFile = function(hashAlg, InFile, pubKey, uid, callback) {
		var request = {
			funcid:27,
			AlgorithmType: hashAlg,
			InFile: InFile,
			PublicKey: pubKey,
			ID: uid
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//XML签名
	this.SOF_SignDataXML = function(container,InData, callback) {
		var request = {
			funcid:30,
			ContainerName: container,
			InData: InData
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//XML验签
	this.SOF_VerifySignedDataXML = function(SignedData, callback) {
		var request = {
			funcid:31,
			SignedData: SignedData
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//解析XML签名数据
	this.SOF_GetXMLSignatureInfo = function(SignedData,Type, callback) {
		var request = {
			funcid:32,
			SignedData: SignedData,
			Type: Type
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//国密时间戳
	this.SOF_Ext_TspGetTime = function(callback) {
		var request = {
			funcid:33
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//加盖时间戳
	this.SOF_Ext_TspGetStamp = function(InData,AlgType, callback) {
		var request = {
			funcid:34,
			InData: InData,
			AlgType: AlgType
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//验证时间戳
	this.SOF_Ext_TspVerifyStamp = function(InData,SealData,Cert, callback) {
		var request = {
			funcid:35,
			InData: InData,
			SealData: SealData,
			Cert: Cert
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };
	
	//接口控制
	this.SOF_Ext_Control = function(container,CtrlName,CtrlCmd, callback) {
		var request = {
			funcid:36,
			ContainerName: container,
			CtrlName: CtrlName,
			CtrlCmd: CtrlCmd
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//文件对称加密
	 this.SOF_Ext_SymmEncryptFile = function(symmAlg, symmKey, symmIV,inFilePath, outFilePath, callback) {
       var request = {
			funcid:40,
			symmAlg: symmAlg,
			symmKey: symmKey,
			symmIV: symmIV,
			inFilePath: inFilePath,
			outFilePath: outFilePath
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

	//文件对称解密
    this.SOF_Ext_SymmDecryptFile = function(symmAlg, symmKey, symmIV,inFilePath, outFilePath, callback) {
       var request = {
			funcid:41,
			symmAlg: symmAlg,
			symmKey: symmKey,
			symmIV: symmIV,
			inFilePath: inFilePath,
			outFilePath: outFilePath
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };
	
    this.SOF_Ext_Base64Encode = function(InData, callback) {
        var request = {
            funcid:50,
            InData:InData
        };
        
        return _webUtil.Request(JSON.stringify(request), callback);
    };

    this.SOF_Ext_EnumFile = function(container, callback) {
        var request = {
            funcid:51,
            ContainerName:container
        };

		return _webUtil.Request(JSON.stringify(request), callback);
    };

    this.SOF_Ext_CreateFile = function(container, fileName, fileLen, readRights, writeRights, callback) {
        var request = {
            funcid:52,
			ContainerName: container,
			fileName: fileName,
			fileLen: fileLen,
			readRights: readRights,
			writeRights: writeRights
        };

		return _webUtil.Request(JSON.stringify(request), callback);
    };

    this.SOF_Ext_DeleteFile = function(container, fileName, callback) {
        var request = {
            funcid:53,
            ContainerName:container,
            fileName: fileName
        };

		return _webUtil.Request(JSON.stringify(request), callback);
    };
    
    this.SOF_Ext_GetFileAttribute = function(container, fileName, callback) {
        var request = {
            funcid:56,
            ContainerName:container,
            fileName: fileName
        };

		return _webUtil.Request(JSON.stringify(request), callback);
    };
    
    this.SOF_Ext_ReadFile = function(container, fileName, offset, readLen, callback) {
        var request = {
            funcid:54,
            ContainerName:container,
			fileName: fileName,
			offset: offset,
			readLen: readLen
        };

		return _webUtil.Request(JSON.stringify(request), callback);
    };

    this.SOF_Ext_WriteFile = function(container, fileName, offset, dataFmt, fileData, callback) {
        var request = {
            funcid:55,
			ContainerName: container,
			fileName: fileName,
			offset: offset,
			dataFmt: dataFmt,
			fileData: fileData
        };

		return _webUtil.Request(JSON.stringify(request), callback);
    };
    
    this.SOF_Ext_HashData = function(hashAlg, inData, inDataFmt, pubKey, uid, callback) {
        var request = {
            funcid:57,
			hashAlg: hashAlg,
			inData: inData,
			inDataFmt: inDataFmt,
			pubKey: pubKey,
			uid: uid
        };

		return _webUtil.Request(JSON.stringify(request), callback);
    };
    
    this.SOF_Ext_ExportPublicKey = function(container, keyUsage, callback) {
		var request = {
			funcid:59,
			container: container,
			keyUsage: keyUsage
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };
    
    this.SOF_Ext_AsymmEncryptData = function(inData, pubKey, callback) {
		var request = {
			funcid:60,
			inData: inData,
			pubKey: pubKey
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };

    this.SOF_Ext_AsymmDecryptData = function(container, encData, callback) {
		var request = {
			funcid:61,
			container: container,
			encData: encData
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };
    
    this.SOF_Ext_EnumSeal = function(container, callback) {
		var request = {
			funcid:62,
			container: container
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };
    
    this.SOF_Ext_GetSeaInfo = function(container, sealIdx, infoType, callback) {
		var request = {
			funcid:63,
			container: container,
			sealIdx: sealIdx,
			infoType: infoType
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };
    
    this.SOF_Finalize = function(callback) {
       var request = {
			funcid:38
		};
		
		return _webUtil.Request(JSON.stringify(request), callback);
    };
}

var gPKISvc = new GdcaPKIService();

